program explorer_checker;

{$APPTYPE CONSOLE}
{$R+}

uses 
  testlib;

const eps = 0.00001;

var
  xt, yt, zt, dxt, dyt, dzt, r1, r2, xs, ys, zs, xd, yd, zd, tr, xa, ya, za: extended;

function len(dx, dy, dz: extended): extended;
begin
  result := sqrt(dx*dx + dy*dy + dz*dz);
end;

begin
  xt := inf.readreal();
  yt := inf.readreal();
  zt := inf.readreal();
  dxt := inf.readreal();
  dyt := inf.readreal();
  dzt := inf.readreal();
  r1 := inf.readreal();
  r2 := inf.readreal();
  xs := inf.readreal();
  ys := inf.readreal();
  zs := inf.readreal();

  xd := ouf.readreal();
  yd := ouf.readreal();
  zd := ouf.readreal();

  tr := len(dxt, dyt, dzt);
  dxt := dxt / tr; dyt := dyt / tr; dzt := dzt / tr;
  xs := xs - xt; ys := ys - yt; zs := zs - zt;
  xd := xd - xt; yd := yd - yt; zd := zd - zt;

  tr := len(xd - xs, yd - ys, zd - zs);
  if (tr < eps) then
  begin
    if (abs(sqr(r2) - sqr(r1) - sqr(len(xs, ys, zs)) + 2*r1*abs(len(ys*dzt - zs*dyt, -xs*dzt + zs*dxt, xs*dyt - ys*dxt))) > eps) then 
      quit(_wa, 'Participant says that he is already on torus while actually he is not')
    else 
      quit(_ok, 'Participant says that he is already on torus and it is true');
  end;

  xa := xs + (xd - xs) * (1 + r2 / tr);
  ya := ys + (yd - ys) * (1 + r2 / tr);
  za := zs + (zd - zs) * (1 + r2 / tr);

  writeln (len(xa, ya, za) - r1);
  writeln (xa*dxt + ya*dyt + za*dzt);
  writeln (xa*xs + ya*ys + za*zs);

  if (abs(len(xa, ya, za) - r1) > eps) then quit(_wa, 'Axial point is not at distance r1 from center');
  if (abs(xa*dxt + ya*dyt + za*dzt) > eps) then quit(_wa, 'Axial point is not in the symmetry plane of torus');
  if (xa*xs + ya*ys + za*zs < -eps) then quit(_wa, 'It found a perpendicular but it is not the shortest one');

  quit(_ok, 'All checks passed!');
end.
